%define name libservicelog
%define version 1.1.11

Name:           %{name}
Version:        %{version}
Release:        3%{?dist}
Summary:        Servicelog Database and Library

Group:          System Environment/Libraries
License:        LGPLv2
URL:            http://linux-diag.sourceforge.net/servicelog
Source0:        http://downloads.sourceforge.net/linux-diag/%{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  sqlite-devel bison flex

%description
The libservicelgo package contains a library to create and maintain a
database for storing events related to system service.  This database
allows for the logging of serviceable and informational events, and for
the logging of service procedures that have been performed upon the system.


%package        devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description    devel
Contains header files for building with libservicelog.


%prep
%setup -q


%build
%configure --disable-static
%{__make} %{?_smp_mflags}
touch servicelog.db
install -D --mode=754 --group=service servicelog.db \
	$RPM_BUILD_ROOT/var/lib/servicelog/servicelog.db


%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT


%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupdel service
echo "Adding group 'service'"
/usr/sbin/groupadd service

%post -p /sbin/ldconfig

%postun
/sbin/ldconfig
/usr/sbin/groupdel service


%files
%defattr(-,root,root,-)
%doc COPYING NEWS AUTHORS
%exclude %{_libdir}/*.la
%{_libdir}/libservicelog-1.1.so.*
%{_libdir}/*.so
%attr( 754, root, service ) %dir /var/lib/servicelog/servicelog.db

%files devel
%defattr(-,root,root,-)
%{_includedir}/servicelog-1
%{_libdir}/*.la
%{_libdir}/pkgconfig/servicelog-1.pc


%changelog

* Sat Aug 16 2008 Mike Strosaker <strosake at austin.ibm.com> 1.0.1
- Create /var/lib/servicelog/servicelog.db at install time
- Additional comments and code cleanup
- Fix issue with notification tools not being started
- Beautify printing of notification tools

* Tue Mar 04 2008 Mike Strosaker <strosake at austin.ibm.com> 1.0.0
- Initial creation of the package
