/*
servicelogSegFault.cpp
: Grady Jensen (gwjensen@us.ibm.com)

Toy program to showcase a segmentation fault seen when using servicelog.

*/

#include <cstring>
#include <iostream>
#include <unistd.h>
#include <cstdio>
#include <cstdlib>
#include <servicelog-1/servicelog.h>

using std::cout;
using std::cerr;
using std::endl;

int main(int argc, char *argv[]) {
	uint32_t ret = 0;
	servicelog *errorlog;
	
	//open servicelog
	ret = servicelog_open(&errorlog,SL_FLAG_ADMIN);
	
	if ( ret != 0 ){
		cerr << "The service log said : " << servicelog_error(errorlog) << endl;
		exit(-1);
	}
	
	sl_event ErrorEvent;	
	
	//////////////Populate log in Repository/////////////////////////////////
	memset(&ErrorEvent, 0, sizeof(sl_event));
	sl_event *pErrorEvent = &ErrorEvent;
	
	uint32_t RetCode = 0;
	uint32_t FuncRetCode = 0;
	
	ErrorEvent.time_event = NULL;
	ErrorEvent.type = SL_TYPE_BASIC;
	ErrorEvent.severity = 2;
	ErrorEvent.machine_serial = "machine_serial";
	ErrorEvent.machine_model = "machine_model";
	ErrorEvent.next = NULL;
	
	char LocationScope[] = "Bug Repro";        		
	ErrorEvent.refcode = LocationScope;
	
	char LogReturnCodes[] = "Some Error Return";
	ErrorEvent.description = LogReturnCodes; 
	
	ErrorEvent.serviceable = 0;
	ErrorEvent.predictive = 0;
	ErrorEvent.disposition = SL_DISP_RECOVERABLE; 
	ErrorEvent.call_home_status = 0;
	ErrorEvent.closed = 0; 
	
	uint8_t Log[] = "Blah,Blahblahblahblahblahblahblahblahbla";
	ErrorEvent.raw_data_len = 41;
	ErrorEvent.raw_data = Log;
	ErrorEvent.callouts = NULL;
	uint64_t oLogID = 0;
	
	cout << "ARE WE GOING TO BLOW UP?!?!?!?!?!!?.......";
	RetCode = servicelog_event_log(errorlog, &ErrorEvent, &oLogID);
	cout << "nope :(\n";
	if ( RetCode != 0 ){
		cerr << "The service log said : " << servicelog_error(errorlog) << endl;
		exit(-2);
	}
	
	RetCode = servicelog_event_close(errorlog, oLogID);
	
	if ( RetCode != 0 ){
		cerr << "The service log said : " << servicelog_error(errorlog) << endl;
		exit(-3);
	}
	/////////////End populate log in Repository//////////////////////////////


	//Close all connections
	servicelog_close(errorlog);
	
	return 0;
	
}

